#include <wiringPi.h>
#include <iostream>
#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>
#include <sched.h>
#include <sstream>

/*
Par Idleman (idleman@idleman.fr - http://blog.idleman.fr)
Licence : CC by sa
Toutes question sur le blog ou par mail, possibilité de m'envoyer des bières via le blog
*/

using namespace std;


int pin;
bool bit2[26]={};              // 26 bit Identifiant emetteur
bool bit2Interruptor[4]={}; 
int interruptor;
int sender;
string onoff;

void log(string a){
	//Décommenter pour avoir les logs

	//cout << a << endl;
}




void scheduler_realtime() {

struct sched_param p;
p.__sched_priority = sched_get_priority_max(SCHED_RR);
if( sched_setscheduler( 0, SCHED_RR, &p ) == -1 ) {
perror("Failed to switch to realtime scheduler.");
}
}

void scheduler_standard() {

struct sched_param p;
p.__sched_priority = 0;
if( sched_setscheduler( 0, SCHED_OTHER, &p ) == -1 ) {
perror("Failed to switch to normal scheduler.");
}
}



//Envois d'une pulsation (passage de l'etat haut a l'etat bas)
//1 = 310µs haut puis 1340µs bas
//0 = 310µs haut puis 310µs bas
void sendBit(bool b) {
 if (b) {
   digitalWrite(pin, HIGH);
   delayMicroseconds(220);   //275 orinally, but tweaked.
   digitalWrite(pin, LOW);
   delayMicroseconds(1200);  //1225 orinally, but tweaked.
 }
 else {
   digitalWrite(pin, HIGH);
   delayMicroseconds(940);   //275 orinally, but tweaked.
   digitalWrite(pin, LOW);
   delayMicroseconds(460);   //275 orinally, but tweaked.
 }
}

//Calcul le nombre 2^chiffre indiqué, fonction utilisé par itob pour la conversion decimal/binaire
unsigned long power2(int power){
unsigned long integer=1;
for (int i=0; i<power; i++){
  integer*=2;
}
return integer;
} 

//Convertis un nombre en binaire, nécessite le nombre, et le nombre de bits souhaité en sortie (ici 26)
// Stocke le résultat dans le tableau global "bit2"
void itob(unsigned long integer, int length)
{
	for (int i=0; i<length; i++){
	  if ((integer / power2(length-1-i))==1){
		integer-=power2(length-1-i);
		bit2[i]=1;
	  }
	  else bit2[i]=0;
	}
}

void itobInterruptor(unsigned long integer, int length)
{
	for (int i=0; i<length; i++){
	  if ((integer / power2(length-1-i))==1){
		integer-=power2(length-1-i);
		bit2Interruptor[i]=1;
	  }
	  else bit2Interruptor[i]=0;
	}
}




//Envoie d'une paire de pulsation radio qui definissent 1 bit réel : 0 =01 et 1 =10
//c'est le codage de manchester qui necessite ce petit bouzin, ceci permet entre autres de dissocier les données des parasites
void sendPair(bool b) {
 if(b)
 {
   sendBit(true);
   sendBit(true);
 }
 else
 {
   sendBit(false);
   sendBit(true);
 }
}


//Fonction d'envois du signal
//recoit en parametre un booleen définissant l'arret ou la marche du matos (true = on, false = off)
void transmit(int blnOn)
{
 int i;

sendBit(true); //beacon bit

 // Envoi du code emetteur + num prise
 for(i=0; i<10;i++)
 {
   sendPair(bit2[i]);
 // if (bit2[i]) printf("1"); else printf("0");
 }
//printf("\n");
//Envoi commande
sendPair(blnOn);
sendPair(1-blnOn);
}




int main (int argc, char** argv)
{
if (argc < 5)
{
perror("Il manque un argument!\n Appel : [GPIO] [codetelecommande] [numero prise] [on/off]");
return 1;
}

	if (setuid(0))
	{
		perror("setuid");
		return 1;
	}

	scheduler_realtime();

	log("Demarrage du programme");
	pin = atoi(argv[1]);
	sender = atoi(argv[2]);
	interruptor = atoi(argv[3]);
	onoff = argv[4];
	//Si on ne trouve pas la librairie wiringPI, on arrête l'execution
    if(wiringPiSetup() == -1)
    {
        log("Librairie Wiring PI introuvable, veuillez lier cette librairie...");
        return -1;

    }
    pinMode(pin, OUTPUT);

	log("Pin GPIO configure en sortie");

        //decode base
        bit2[0]=(argv[2][0]=='1');
        bit2[1]=(argv[2][1]=='1');
        bit2[2]=(argv[2][2]=='1');
        bit2[3]=(argv[2][3]=='1');
        bit2[4]=(argv[2][4]=='1');

        //decode prise
        bit2[5]=(argv[3][0]=='1');
        bit2[6]=(argv[3][1]=='1');
        bit2[7]=(argv[3][2]=='1');
        bit2[8]=(argv[3][3]=='1');
        bit2[9]=(argv[3][4]=='1');


		 delay(100);                 // attendre 10 ms (sinon le socket nous ignore)
	
	
	if(onoff=="on"){
	 system("/etc/lcd/screen -p \"Radio signal ON...\"");
	 log("envois du signal ON");
	 for(int i=0;i<10;i++){
		 transmit(true);            // envoyer ON
		 delay(11);                 // attendre 10 ms (sinon le socket nous ignore)
	 }

	}else{
	 system("/etc/lcd/screen -p \"Radio signal OFF...\"");
	 log("envois du signal OFF");
	 for(int i=0;i<10;i++){
		 transmit(false);           // envoyer OFF
		 delay(11);                // attendre 10 ms (sinon le socket nous ignore)
	 }
	}

	 log("fin du programme");    // execution terminée.


	scheduler_standard();
}

